﻿using System;
using System.Globalization;

namespace ChartSample
{
    public class Candle
    {
        public DateTime Time;
        public double Open;
        public double High;
        public double Close;
        public double Low;
        public double Volume;

        public void SetCandleFromString(string In) // загрузить данные из файла
        {//20131001,100000,97.8000000,97.9900000,97.7500000,97.9000000,1
            //<DATE>,<TIME>,<OPEN>,<HIGH>,<LOW>,<CLOSE>,<VOLUME>
            string[] lockal = In.Split(',');

            Time = new DateTime(Convert.ToInt32(lockal[0][0].ToString() + lockal[0][1].ToString() + lockal[0][2].ToString() + lockal[0][3].ToString()),
                 Convert.ToInt32(lockal[0][4].ToString() + lockal[0][5].ToString()),
                 Convert.ToInt32(lockal[0][6].ToString() + lockal[0][7].ToString()),
                 Convert.ToInt32(lockal[1][0].ToString() + lockal[1][1].ToString()),
                 Convert.ToInt32(lockal[1][2].ToString() + lockal[1][3].ToString()),
                 Convert.ToInt32(lockal[1][4].ToString() + lockal[1][5].ToString()));

            string[] sIn = In.Split(',');

            string[] shit = sIn[2].Split('.');
            if (shit.Length == 2)
            {
                Open = Convert.ToDouble(shit[0] + ',' + shit[1]);
            }
            else
            {
                Open = Convert.ToDouble(shit[0]);
            }

            shit = sIn[3].Split('.');

            if (shit.Length == 2)
            {
                High = Convert.ToDouble(shit[0] + ',' + shit[1]);
            }
            else
            {
                High = Convert.ToDouble(shit[0]);
            }

            shit = sIn[4].Split('.');
            if (shit.Length == 2)
            {
                Low = Convert.ToDouble(shit[0] + ',' + shit[1]);
            }
            else
            {
                Low = Convert.ToDouble(shit[0]);
            }

            shit = sIn[5].Split('.');
            if (shit.Length == 2)
            {
                Close = Convert.ToDouble(shit[0] + ',' + shit[1]);
            }
            else
            {
                Close = Convert.ToDouble(shit[0]);
            }

            shit = sIn[6].Split('.');

            if (shit.Length == 2)
            {
                Volume = Convert.ToDouble(shit[0] + ',' + shit[1]);
            }
            else
            {
                Volume = Convert.ToDouble(shit[0]);
            }
        }

        public string GetString() // взять строку эквивалент сохранённой в файле
        { //20131001,100000,97.8000000,97.9900000,97.7500000,97.9000000
            string result = string.Empty;

            result += Time.Year.ToString();
            if (Time.Month > 9)
            {
                result += Time.Month.ToString();
            }
            else
            {
                result += "0" + Time.Month.ToString();
            }
            if (Time.Day > 9)
            {
                result += Time.Day.ToString() + ",";
            }
            else
            {
                result += "0" + Time.Day.ToString() + ",";
            }

            if (Time.Hour > 9)
            {
                result += Time.Hour.ToString();
            }
            else
            {
                result += "0" + Time.Hour.ToString();
            }
            if (Time.Minute > 9)
            {
                result += Time.Minute.ToString();
            }
            else
            {
                result += "0" + Time.Minute.ToString();
            }
            if (Time.Second > 9)
            {
                result += Time.Second.ToString() + ",";
            }
            else
            {
                result += "0" + Time.Second.ToString() + ",";
            }



            result += Open.ToString(CultureInfo.InvariantCulture) + ",";
            result += High.ToString(CultureInfo.InvariantCulture) + ",";
            result += Low.ToString(CultureInfo.InvariantCulture) + ",";
            result += Close.ToString(CultureInfo.InvariantCulture) + ",";
            return result;
        }

        public string GetBeautifulString() // взять строку с подписями
        {//Date - 20131001 Time - 100000 Open - 97.8000000 High - 97.9900000 Low - 97.7500000 Close - 97.9000000

            string result = string.Empty;
            result += "Date: ";
            result += Time.Year.ToString();
            if (Time.Month > 9)
            {
                result += Time.Month.ToString();
            }
            else
            {
                result += "0" + Time.Month.ToString();
            }

            if (Time.Day > 9)
            {
                result += Time.Day.ToString();
            }
            else
            {
                result += "0" + Time.Day.ToString();
            }

            result += " Time: ";

            if (Time.Hour > 9)
            {
                result += Time.Hour.ToString();
            }
            else
            {
                result += "0" + Time.Hour.ToString();
            }
            if (Time.Minute > 9)
            {
                result += Time.Minute.ToString();
            }
            else
            {
                result += "0" + Time.Minute.ToString();
            }
            if (Time.Second > 9)
            {
                result += Time.Second.ToString();
            }
            else
            {
                result += "0" + Time.Second.ToString();
            }


            result += " Open: ";
            result += Open.ToString();
            result += " High: ";
            result += High.ToString();
            result += " Low: ";
            result += Low.ToString();
            result += " Close: ";
            result += Close.ToString();

            return result;
        }
    }
}
